#
# Create a namespace.
# 
# Annotations defined in config.system.namespace_annotations will be copied from the system namespace to the new namespace. 
# Existing annotations are preserved (because kubernetes.core.k8s does not remove them).
# Also, a label will be set with the name of the namespace to assist on networkpolicies, and extra labels can be added in
# variable namespace_labels. 
# 
# Example config: 
#   config:
#     system: 
#       namespace_annotations:
#       - my_first_annotation
#       - my_second_annotation
#

- name: Get system namespace
  kubernetes.core.k8s_info:
    kind: Namespace
    name: "{{ platform.prefix }}-system"
  register: system_namespace
  when: config.system.namespace_annotations is defined
  failed_when: system_namespace.resources | length == 0 

- name: Collect Namespace annotations
  set_fact: 
    namespace_annotations: "{{ namespace_annotations | default({}) | combine ({ annotation : system_namespace.resources[0].metadata.annotations[annotation] }) }}"
  loop_control: 
    loop_var: annotation
  loop: "{{ config.system.namespace_annotations | default([]) }}"

- name: Collect Namespace labels
  set_fact: 
    namespace_labels: "{{ namespace_labels | default({}) | combine(fixed_labels) }}"
  vars:
    fixed_labels:
      name : "{{ namespace }}"

- name: Create namespace {{ namespace }}
  kubernetes.core.k8s:
    name: "{{ namespace }}"
    api_version: v1
    kind: Namespace
    state: present
    definition: 
      metadata: 
        annotations: "{{ namespace_annotations | default(omit) }}"
        labels: "{{ namespace_labels }}"
